/* This program Estimates the Lewbel, McFadden, and Linton Semiparametric WTP estimators on data        
25/05/05 */

new;
/*cls ;*/

t=1;


tt=hsec ;
output file=wtp.out reset ;	

load data;
lambda=0.5;

n= rows(data);
nk=rows(data') ;
nb=200 ;

y1 = data[.,10] ;
v1=data[.,9] ;
y2 = data[.,12] ;
v2=data[.,11] ;
/*
library pgraph;
_plctrl=-1;
xy(v1,v2);
*/
a1 = (y1.==0).*(y2.==1);
a2 = (y1.==1).*(y2.==0) ;

data1=selif(data,(a1.==1)) ;
data2=selif(data,(a2.==1)) ;
data=data1|data2 ;

n= rows(data);
v1=data[.,9] ;

v2=data[.,11] ; /* SEcond bid */
y1=data[.,10] ; /* Y associated wiht first bid*/
y2=data[.,12] ;/* Y associated wiht second bid*/

wmax=maxc((v1~v2)');
wmin=minc((v1~v2)');

meanc(wmin)~meanc(wmax) ;




yearca=data[.,1] ;
sex =  data[.,2]-1 ;
lnage=ln(data[.,3]) ;
educ=data[.,4] ;
race=(data[.,5].==1) ;
envorg=data[.,6] ;
earning=data[.,7] ;
logearning=data[.,8] ;


y=y1;
vv=v1;
y=y2;
vv=v2;


x=yearca~sex~lnage~educ~race~envorg~logearning ;

muhat6bm=zeros(nb,1) ;
muhat3bm=zeros(nb,1) ;
muhat4bm=zeros(nb,1) ;
mu1b=zeros(nb,1) ;
thetasb=zeros(nb,rows(x')+1) ;

kappa = meanc(vv) ;

/* {muhat3,muhat4,muhat6,thetas,m1}= semipbc(x,y,vv,kappa,lambda) ;*/

/* {muhat3,muhat4,muhat6,thetas,m1}= semiplog(x,y,vv,kappa) ;*/

{muhat3,muhat4,muhat6,thetas,m1}= semip(x,y,vv,kappa) ;


xx = ones(n,1)~x ;
fit =xx*thetas ;
  
/* compute bootstrap standard errors */

t=zeros(rows(x')+1,1);
data=y~vv~x ;

for ib(1,nb,1) ;

datab=bootp_vm(data);
yb = datab[.,1] ;
vvb=datab[.,2] ;
xb=datab[.,3:9] ;


/* {muhat3b,muhat4b,muhat6b,t,m1b}= semipbc(xb,yb,vvb,kappa,lambda) ;*/

/*  {muhat3b,muhat4b,muhat6b,t, m1b}= semiplog(xb,yb,vvb,kappa) ;*/

{muhat3b,muhat4b,muhat6b,t,m1b}= semip(xb,yb,vvb,kappa) ;

muhat3bm[ib]=median(muhat3b) ;
muhat4bm[ib]=median(muhat4b) ;
muhat6bm[ib]=median(muhat6b) ;
mu1b[ib]=m1b ;
thetasb[ib,.]=t';

endfor;


k=rows(x')+1;
xname = "Constant "|"Yearca"|"Female"|"logAge"|"Education"|"White"|"Envirorg"|"logInc"|"Mu3"|"Mu4"|"Mu6"|"Mu1" ;
yname="wtp" ;

qname = "Covariates" ;

lb = quantile(thetasb,0.025)' ;
ub = quantile(thetasb,0.975)' ;

lb=lb|quantile(muhat3bm,0.025)|quantile(muhat4bm,0.025)|quantile(muhat6bm,0.025)|quantile(mu1b,0.025) ;
ub=ub|quantile(muhat3bm,0.975)|quantile(muhat4bm,0.975)|quantile(muhat6bm,0.975)|quantile(mu1b,0.975) ;
thetas= thetas|median(muhat3)|median(muhat4)|median(muhat6)|m1;

ff = "#*.*lG"~16~6;
"Unsmoothed Estimation";
print ("Dependent Variable:     " $+ yname);
print ("Regressor Variable:     " $+ qname);


  
"";
p = printfm("Variable"~"Estimate"~"Lower Bound"~"Upper Bound",0~0~0~0,ff);"";
"       __________________________________________";
p = printfm(xname~thetas~lb~ub,0~1~1~1,ff);"";
"";
"Observations                      " n;
"Degrees of Freedom                " (n-k);
/* "Sum of Squared Residuals          " meanc(resid.^2); */
"";"";
"__________________________________________________";
"";"";


hv=ones(n,1)/(maxc(vv)-minc(vv))  ; 
sr =kappa + (((y - (vv.<kappa)) )./hv) ;
h=1.06*stdc(fit)*n^-0.2 ;
dd=fit~sr ;
dd=sortc(dd,1) ;
fit=dd[.,1] ;
sr=dd[.,2] ;
mu=matlocl(fit,fit,h)*sr;


library pgraph ;
xy(fit,fit~mu);



ttn=hsec ;
print "Time in Hours";; print (ttn-tt)/360000 ;

output off;
stop ;








fn fig(z) = exp(-.5*(z.^2))/sqrt(2*pi) ;
fn fi(z) = exp(-.5*(z.^2))/sqrt(2*pi) ;
fn fibq(z) = (15/16)*(abs(z).<1).*( (ones(n,1)-(z.^2)).^2) ;



/*  Main Procedure */


/* This is the main wtp procedure */

proc(5)=semip(x,y,vv,kappa) ;
local n,xx,thetas,uhat,m,hm,fihatp,h,fihats,muhat3,muhat4,muhat6 ;
local vloc,cl,cu,hc,nc,dv,hv,sr,m1 ;

n=rows(x) ;

cl=minc(vv) ;
cu=maxc(vv) ;
/*vloc=unique(vv,1) ;
hc = counts(vv,vloc)/n ;
nc=rows(hc) ;
dv = (vv.*ones(1,nc).==ones(n,1)*vloc') ;

hv = dv*hc ;
*/
hv=ones(n,1)/(maxc(vv)-minc(vv))  ; 
sr =kappa + (((y - (vv.<kappa)) )./hv) ;

xx = ones(n,1)~x ;
if det(xx'xx) .ne 0 ;
thetas = inv(xx'xx)*xx'sr ;
else ;
thetas = inv(xx'xx+0.01*eye(rows(xx'xx)))*xx'sr ;
endif;

Uhat = xx*thetas - vv ;
m=xx*thetas*ones(1,n) - ones(n,1)*Uhat' ;
hm= (cl*ones(n,n).<m).*(m.<cu*ones(n,n)) ;
hm = hm./(cu-cl) ;
fihatp = meanc(hm') ; 

muhat6 = xx*thetas ;
muhat3 = xx*thetas + meanc( (y-(Uhat.>0))./fihatp)*ones(n,1) ;

h=1.06*stdc(Uhat)*n^-0.2 ;

fihats= sumc(matker(Uhat,Uhat,h))/(n*h) ;
muhat4 = xx*thetas + meanc( (y-(Uhat.>0))./fihats)*ones(n,1) ;
m1 = meanc(sr) ;

retp(muhat3,muhat4,muhat6,thetas,m1) ;
endp ;

/* This is the wtp procedure in logs */
proc(5)=semiplog(x,y,vv,kappa) ;
local n,xx,thetas,uhat,m,hm,fihatp,h,fihats,muhat3,muhat4,muhat6 ;
local vloc,cl,cu,hc,nc,dv,hv,sr ;
local xxx,sw,fits,fit,kx,tc,zu,m1;

n=rows(x) ;

/* Estimation of parameters */

cl=minc(vv) ;
cu=maxc(vv) ;
/*vloc=unique(vv,1) ;
hc = counts(vv,vloc)/n ;
nc=rows(hc) ;
dv = (vv.*ones(1,nc).==ones(n,1)*vloc') ;

hv = dv*hc ;
*/
hv=ones(n,1)/(maxc(vv)-minc(vv))  ; 
sr =ln(kappa) + (((y - (vv.<kappa)) )./(vv.*hv)) ;

xx = ones(n,1)~x ;
kx=rows(xx');
if det(xx'xx) .ne 0 ;
thetas = inv(xx'xx)*xx'sr ;
else ;
thetas = inv(xx'xx+0.01*eye(rows(xx'xx)))*xx'sr ;
endif;


/*
tc=thetas[1];
xx=xx[.,2:kx] ;
thetas=thetas[2:kx] ;*/
Uhat = xx*thetas - ln(vv) ;


m=exp(xx*thetas*ones(1,n) - ones(n,1)*Uhat') ;
hm= (cl*ones(n,n).<m).*(m.<cu*ones(n,n)).*m ;
hm = hm./(cu-cl) ;
fihatp = meanc(hm') ; 

sw = kappa +  (((y - (vv.<kappa)) )./hv) ;
m1=meanc(sw) ;
fit = xx*thetas ;
xxx = ones(n,1)~fit~fit.^2~fit.^3 ;
muhat6 = xxx*inv(xxx'xxx)*xxx'sw ;

zu = exp(meanc(xx*thetas) - Uhat) ;
muhat3 = exp(meanc(xx*thetas)) + meanc( zu.*(y-(Uhat.>0))./fihatp)*ones(n,1) ;

h=1.06*stdc(Uhat)*n^-0.2 ;

fihats= sumc(matker(Uhat,Uhat,h))/(n*h) ;
muhat4 = exp(meanc(xx*thetas)) + meanc(zu.*(y-(Uhat.>0))./fihats)*ones(n,1) ;


retp(muhat3,muhat4,muhat6,thetas,m1) ;
endp ;


/* This is the wtp procedure in box-cox transform with lambda */
proc(5)=semipbc(x,y,vv,kappa,lambda) ;
local n,xx,thetas,uhat,m,hm,fihatp,h,fihats,muhat3,muhat4,muhat6 ;
local vloc,cl,cu,hc,nc,dv,hv,sr ;
local xxx,sw,fits,fit,kx,tc,zu,m1;

n=rows(x) ;

/* Estimation of parameters */

cl=minc(vv) ;
cu=maxc(vv) ;
/*vloc=unique(vv,1) ;
hc = counts(vv,vloc)/n ;
nc=rows(hc) ;
dv = (vv.*ones(1,nc).==ones(n,1)*vloc') ;

hv = dv*hc ;
*/
hv=ones(n,1)/(maxc(vv)-minc(vv))  ; 
sr =(((kappa^lambda)-1)/lambda) + ((vv.^(lambda-1)).*((y - (vv.<kappa)) )./hv) ;

xx = ones(n,1)~x ;
kx=rows(xx');
if det(xx'xx) .ne 0 ;
thetas = inv(xx'xx)*xx'sr ;
else ;
thetas = inv(xx'xx+0.01*eye(rows(xx'xx)))*xx'sr ;
endif;


/*
tc=thetas[1];
xx=xx[.,2:kx] ;
thetas=thetas[2:kx] ;*/
Uhat = xx*thetas - (((vv^lambda)-1)/lambda) ;


m=xx*thetas*ones(1,n) - ones(n,1)*Uhat' ;
m = (lambda*m+1).^(1/lambda) ;
hm= (cl*ones(n,n).<m).*(m.<cu*ones(n,n)) ;
m = (lambda*m+1).^((1/lambda)-1) ;
hm=hm.* m;
hm = hm./(cu-cl) ;
fihatp = meanc(hm') ; 

sw = kappa +  (((y - (vv.<kappa)) )./hv) ;
m1=meanc(sw) ;
fit = xx*thetas ;
xxx = ones(n,1)~fit~fit.^2~fit.^3 ;
muhat6 = xxx*inv(xxx'xxx)*xxx'sw ;

zu = meanc(xx*thetas) - Uhat ;
zu = (lambda*zu+1).^((1/lambda)-1) ;
muhat3 = (lambda*meanc(xx*thetas)+1).^(1/lambda)+ meanc( zu.*(y-(Uhat.>0))./fihatp)*ones(n,1) ;

h=1.06*stdc(Uhat)*n^-0.2 ;

fihats= sumc(matker(Uhat,Uhat,h))/(n*h) ;
muhat4 = (lambda*meanc(xx*thetas)+1).^(1/lambda)+ meanc( zu.*(y-(Uhat.>0))./fihats)*ones(n,1) ;



retp(muhat3,muhat4,muhat6,thetas,m1) ;
endp ;







/* This procedure computes the matrix of kernel regression weights at evaluation points xe using data x*/

proc matker(xe,x,h) ;
local m,n,K,hl ;
n = rows(x);
/* hl=((5/hr).*abs(xe) +ones(n,1))*h ; */
m = (xe*ones(1,n) - ones(n,1)*x')/h ;

K = fig(m) ;

/* K = K./sumc(K') ; */

retp(K) ;
endp ;

/* This procedure computes the matrix of local linear regression weights at evaluation points xe using data x*/

proc matlocl(xe,x,h) ;
local m,n,K, K1,k2,k3,hl,nk ;

n=rows(x) ;
nk=rows(xe) ;
/* hl=((5/hr).*abs(xe) +ones(n,1))*h ; */
m = (xe*ones(1,n) - ones(nk,1)*x')./h ;
K1 = fig(m) ;
K2 = K1.*m ;
K3 = K2.*m ;

K = (K1.*sumc(K3')) - (K2.*sumc(K2'))  ;
/* K=diagrv(K,zeros(n,1)) ; */
K = K./sumc(K') ;

retp(K) ;
endp ;


proc matquadl(xe,x,h) ;
local m,n,K, K1,k2,k3,k4,k5, hl ;
local t1,t2,t3 ;

n=rows(x) ;
/* hl=((5/hr).*abs(xe) +ones(n,1))*h ; */
m = (xe*ones(1,n) - ones(n,1)*x')./h ;
K1 = fig(m) ;
K2 = K1.*m ;
K3 = K2.*m ;
K4 = K3.*m ;
K5 = K4.*m ;
t1 = sumc(K3').*sumc(K5') - (sumc(K4').^2) ;
t2 = -sumc(K2').*sumc(K5')+ (sumc(K3').*sumc(K4')) ;
t3 = sumc(K2').*sumc(K4') - (sumc(K3').^2) ;
K = (K1.*t1)+ (K2.*t2)+(k3.*t3)  ;
K = K./sumc(K') ;

retp(K) ;
endp ;



/* This procedure computes the matrix of bivariate local linear estimates at evaluation points xe,ze using data y,x,z*/

proc matloclbc(xe,ze,y,x,z,h) ;
local m,n, nne, nnz,K, K1,k2,k3,hl ;
local fit,S1,S2,S3,S4,S5,S6,T1,T2,T3,a1,a2,a3,a4,m1,m2 ;
n=rows(x) ;
nne=rows(xe) ;
nnz=rows(ze) ;
hl=h ;
/* hl=((5/hr).*abs(xe) +ones(n,1))*h ; */

m1 = (xe*ones(1,n) - ones(nne,1)*x')./hl ; 
K1 = fi(m1)./hl ;
hl=hl*stdc(z)/stdc(x) ;
m2 = (ze*ones(1,n) - ones(nnz,1)*z')./hl ;
K2 = fi(m2)./hl ;

S1 = K1*K2'/n ;
S2 = (K1.*m1)*K2'/n ;
S3=K1*(K2.*m2)'/n ;
S4 = (K1.*m1.*m1)*K2'/n ;
S5 = (K1.*m1)*(K2.*m2)'/n ;
S6 = K1*(K2.*m2.*m2)'/n ;
T1 = (K1.*y')*K2'/n ;
T2 = (K1.*y'.*m1)*K2'/n ;
T3 = (K1.*y')*(K2.*m2)' /n;

a1 =S4.*S6-S5.^2 ;
a2 = S2.*S6 - S3.*S5 ;
a3 = S2.*S5-S3.*S4 ;
a4 = S1.*S4.*S6 - S1.*(S5.^2) - (S2.^2).*S6 + 2*S2.*S3.*S5 - (S3.^2).*S4  ;

fit = (T1.*a1 - T2.*a2+T3.*a3)./a4 ;
 
retp(fit) ;
endp ;



/* standard pair bootstrap algorithm (vm) */

proc bootp_vm(x);

	local n,y;

	n = rows(x);


	y  =  x[trunc(rndu(n,1)*n)+1,.];



	retp(y);

endp;
